/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the GoogleAdsConnectorFormAllOf type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GoogleAdsConnectorFormAllOf{}

// GoogleAdsConnectorFormAllOf struct for GoogleAdsConnectorFormAllOf
type GoogleAdsConnectorFormAllOf struct {
	// OAuthId
	OAuthId *string `json:"oAuthId,omitempty"`
	// Data source label
	Label *string `json:"label,omitempty"`
	// Customer Id
	CustomerId *string `json:"customerId,omitempty"`
	// Customer Client Id
	CustomerClientId *string `json:"customerClientId,omitempty"`
	// Attribute
	Attribute []string `json:"attribute,omitempty"`
	// Segment
	Segment []string `json:"segment,omitempty"`
	// Metric
	Metric []string `json:"metric,omitempty"`
	// Report type
	ReportType *string `json:"reportType,omitempty"`
	// Date range.
	DateRange *string `json:"dateRange,omitempty"`
}

// NewGoogleAdsConnectorFormAllOf instantiates a new GoogleAdsConnectorFormAllOf object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGoogleAdsConnectorFormAllOf() *GoogleAdsConnectorFormAllOf {
	this := GoogleAdsConnectorFormAllOf{}
	return &this
}

// NewGoogleAdsConnectorFormAllOfWithDefaults instantiates a new GoogleAdsConnectorFormAllOf object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGoogleAdsConnectorFormAllOfWithDefaults() *GoogleAdsConnectorFormAllOf {
	this := GoogleAdsConnectorFormAllOf{}
	return &this
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *GoogleAdsConnectorFormAllOf) GetOAuthId() string {
	if o == nil || IsNil(o.OAuthId) {
		var ret string
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAdsConnectorFormAllOf) GetOAuthIdOk() (*string, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *GoogleAdsConnectorFormAllOf) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given string and assigns it to the OAuthId field.
func (o *GoogleAdsConnectorFormAllOf) SetOAuthId(v string) {
	o.OAuthId = &v
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *GoogleAdsConnectorFormAllOf) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAdsConnectorFormAllOf) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *GoogleAdsConnectorFormAllOf) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *GoogleAdsConnectorFormAllOf) SetLabel(v string) {
	o.Label = &v
}

// GetCustomerId returns the CustomerId field value if set, zero value otherwise.
func (o *GoogleAdsConnectorFormAllOf) GetCustomerId() string {
	if o == nil || IsNil(o.CustomerId) {
		var ret string
		return ret
	}
	return *o.CustomerId
}

// GetCustomerIdOk returns a tuple with the CustomerId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAdsConnectorFormAllOf) GetCustomerIdOk() (*string, bool) {
	if o == nil || IsNil(o.CustomerId) {
		return nil, false
	}
	return o.CustomerId, true
}

// HasCustomerId returns a boolean if a field has been set.
func (o *GoogleAdsConnectorFormAllOf) HasCustomerId() bool {
	if o != nil && !IsNil(o.CustomerId) {
		return true
	}

	return false
}

// SetCustomerId gets a reference to the given string and assigns it to the CustomerId field.
func (o *GoogleAdsConnectorFormAllOf) SetCustomerId(v string) {
	o.CustomerId = &v
}

// GetCustomerClientId returns the CustomerClientId field value if set, zero value otherwise.
func (o *GoogleAdsConnectorFormAllOf) GetCustomerClientId() string {
	if o == nil || IsNil(o.CustomerClientId) {
		var ret string
		return ret
	}
	return *o.CustomerClientId
}

// GetCustomerClientIdOk returns a tuple with the CustomerClientId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAdsConnectorFormAllOf) GetCustomerClientIdOk() (*string, bool) {
	if o == nil || IsNil(o.CustomerClientId) {
		return nil, false
	}
	return o.CustomerClientId, true
}

// HasCustomerClientId returns a boolean if a field has been set.
func (o *GoogleAdsConnectorFormAllOf) HasCustomerClientId() bool {
	if o != nil && !IsNil(o.CustomerClientId) {
		return true
	}

	return false
}

// SetCustomerClientId gets a reference to the given string and assigns it to the CustomerClientId field.
func (o *GoogleAdsConnectorFormAllOf) SetCustomerClientId(v string) {
	o.CustomerClientId = &v
}

// GetAttribute returns the Attribute field value if set, zero value otherwise.
func (o *GoogleAdsConnectorFormAllOf) GetAttribute() []string {
	if o == nil || IsNil(o.Attribute) {
		var ret []string
		return ret
	}
	return o.Attribute
}

// GetAttributeOk returns a tuple with the Attribute field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAdsConnectorFormAllOf) GetAttributeOk() ([]string, bool) {
	if o == nil || IsNil(o.Attribute) {
		return nil, false
	}
	return o.Attribute, true
}

// HasAttribute returns a boolean if a field has been set.
func (o *GoogleAdsConnectorFormAllOf) HasAttribute() bool {
	if o != nil && !IsNil(o.Attribute) {
		return true
	}

	return false
}

// SetAttribute gets a reference to the given []string and assigns it to the Attribute field.
func (o *GoogleAdsConnectorFormAllOf) SetAttribute(v []string) {
	o.Attribute = v
}

// GetSegment returns the Segment field value if set, zero value otherwise.
func (o *GoogleAdsConnectorFormAllOf) GetSegment() []string {
	if o == nil || IsNil(o.Segment) {
		var ret []string
		return ret
	}
	return o.Segment
}

// GetSegmentOk returns a tuple with the Segment field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAdsConnectorFormAllOf) GetSegmentOk() ([]string, bool) {
	if o == nil || IsNil(o.Segment) {
		return nil, false
	}
	return o.Segment, true
}

// HasSegment returns a boolean if a field has been set.
func (o *GoogleAdsConnectorFormAllOf) HasSegment() bool {
	if o != nil && !IsNil(o.Segment) {
		return true
	}

	return false
}

// SetSegment gets a reference to the given []string and assigns it to the Segment field.
func (o *GoogleAdsConnectorFormAllOf) SetSegment(v []string) {
	o.Segment = v
}

// GetMetric returns the Metric field value if set, zero value otherwise.
func (o *GoogleAdsConnectorFormAllOf) GetMetric() []string {
	if o == nil || IsNil(o.Metric) {
		var ret []string
		return ret
	}
	return o.Metric
}

// GetMetricOk returns a tuple with the Metric field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAdsConnectorFormAllOf) GetMetricOk() ([]string, bool) {
	if o == nil || IsNil(o.Metric) {
		return nil, false
	}
	return o.Metric, true
}

// HasMetric returns a boolean if a field has been set.
func (o *GoogleAdsConnectorFormAllOf) HasMetric() bool {
	if o != nil && !IsNil(o.Metric) {
		return true
	}

	return false
}

// SetMetric gets a reference to the given []string and assigns it to the Metric field.
func (o *GoogleAdsConnectorFormAllOf) SetMetric(v []string) {
	o.Metric = v
}

// GetReportType returns the ReportType field value if set, zero value otherwise.
func (o *GoogleAdsConnectorFormAllOf) GetReportType() string {
	if o == nil || IsNil(o.ReportType) {
		var ret string
		return ret
	}
	return *o.ReportType
}

// GetReportTypeOk returns a tuple with the ReportType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAdsConnectorFormAllOf) GetReportTypeOk() (*string, bool) {
	if o == nil || IsNil(o.ReportType) {
		return nil, false
	}
	return o.ReportType, true
}

// HasReportType returns a boolean if a field has been set.
func (o *GoogleAdsConnectorFormAllOf) HasReportType() bool {
	if o != nil && !IsNil(o.ReportType) {
		return true
	}

	return false
}

// SetReportType gets a reference to the given string and assigns it to the ReportType field.
func (o *GoogleAdsConnectorFormAllOf) SetReportType(v string) {
	o.ReportType = &v
}

// GetDateRange returns the DateRange field value if set, zero value otherwise.
func (o *GoogleAdsConnectorFormAllOf) GetDateRange() string {
	if o == nil || IsNil(o.DateRange) {
		var ret string
		return ret
	}
	return *o.DateRange
}

// GetDateRangeOk returns a tuple with the DateRange field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAdsConnectorFormAllOf) GetDateRangeOk() (*string, bool) {
	if o == nil || IsNil(o.DateRange) {
		return nil, false
	}
	return o.DateRange, true
}

// HasDateRange returns a boolean if a field has been set.
func (o *GoogleAdsConnectorFormAllOf) HasDateRange() bool {
	if o != nil && !IsNil(o.DateRange) {
		return true
	}

	return false
}

// SetDateRange gets a reference to the given string and assigns it to the DateRange field.
func (o *GoogleAdsConnectorFormAllOf) SetDateRange(v string) {
	o.DateRange = &v
}

func (o GoogleAdsConnectorFormAllOf) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GoogleAdsConnectorFormAllOf) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OAuthId) {
		toSerialize["oAuthId"] = o.OAuthId
	}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.CustomerId) {
		toSerialize["customerId"] = o.CustomerId
	}
	if !IsNil(o.CustomerClientId) {
		toSerialize["customerClientId"] = o.CustomerClientId
	}
	if !IsNil(o.Attribute) {
		toSerialize["attribute"] = o.Attribute
	}
	if !IsNil(o.Segment) {
		toSerialize["segment"] = o.Segment
	}
	if !IsNil(o.Metric) {
		toSerialize["metric"] = o.Metric
	}
	if !IsNil(o.ReportType) {
		toSerialize["reportType"] = o.ReportType
	}
	if !IsNil(o.DateRange) {
		toSerialize["dateRange"] = o.DateRange
	}
	return toSerialize, nil
}

type NullableGoogleAdsConnectorFormAllOf struct {
	value *GoogleAdsConnectorFormAllOf
	isSet bool
}

func (v NullableGoogleAdsConnectorFormAllOf) Get() *GoogleAdsConnectorFormAllOf {
	return v.value
}

func (v *NullableGoogleAdsConnectorFormAllOf) Set(val *GoogleAdsConnectorFormAllOf) {
	v.value = val
	v.isSet = true
}

func (v NullableGoogleAdsConnectorFormAllOf) IsSet() bool {
	return v.isSet
}

func (v *NullableGoogleAdsConnectorFormAllOf) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGoogleAdsConnectorFormAllOf(val *GoogleAdsConnectorFormAllOf) *NullableGoogleAdsConnectorFormAllOf {
	return &NullableGoogleAdsConnectorFormAllOf{value: val, isSet: true}
}

func (v NullableGoogleAdsConnectorFormAllOf) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGoogleAdsConnectorFormAllOf) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
